VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CSubdivision"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Option Base 1

Enum enSearchOption
    soName = &H0
    soCCode = &H1
    soUID = &H2
    soParenID = &H3
    soLevel = &H4
    soNameAndLevel = &H5
End Enum

Private pName As String
Private pCCode As String
Private pMach As Boolean
Private pLevel As Long
Private pUID As Long
Private pParentID As Long

'Private pDateCreated As Date
'Private pDateDissolved As Date

Public Units As New Scripting.Dictionary
'Public Units As New Collection


Public Property Let Level(value As Long)
    pLevel = CLng(value)
End Property

Public Property Get Level() As Long
    Level = pLevel
End Property

Public Property Let UID(value As Long)
    pUID = CLng(value)
End Property

Public Property Get UID() As Long
    UID = pUID
End Property

Public Property Let ParentID(value As Long)
    pParentID = CLng(value)
End Property

Public Property Get ParentID() As Long
    ParentID = pParentID
End Property


Public Property Get Name() As String
    Name = pName
End Property

Public Property Let Name(value As String)
    pName = CStr(value)
End Property


Public Property Get CCode() As String
    CCode = pCCode
End Property

Public Property Let CCode(value As String)
    pCCode = CStr(value)
    pLevel = Len(CStr(value)) \ 2
End Property

Public Property Get Mach() As Boolean
    Mach = pMach
End Property

Public Property Let Mach(value As Boolean)
    pMach = CBool(value)
End Property


Public Function Delete(Target As CSubdivision) As Boolean

Dim i As Integer
Dim Child As CSubdivision

    For i = 1 To Units.Count
        If Units.Item(i) Is Target Then
            Units.Remove i
            Delete = True
            Exit Function
        End If
    Next i
    
    For Each Child In Units
        If Child.Delete(Target) Then
            Delete = True
            Exit Function
        End If
    Next Child
    
End Function


Public Function Find(What As Variant, Optional SearchOption As enSearchOption) As CSubdivision

Dim Unit As CSubdivision
Dim Child As CSubdivision

SearchOption = IIf(IsMissing(SearchOption), soUID, SearchOption)

Select Case SearchOption
    Case soUID
        If CLng(What) = pUID Then
         Set Find = Me
         Exit Function
        End If
    
    Case soCCode
        If CLng(What) = pCCode Then
         Set Find = Me
         Exit Function
        End If
    
    
    Case soParenID
        If CLng(What) = pParentID Then
         Set Find = Me
         Exit Function
        End If
    
    
    Case soName
        If CStr(What) = pName Then
         Set Find = Me
         Exit Function
        End If
        
    Case soLevel
        If CStr(What) = pLevel Then
         Set Find = Me
         Exit Function
        End If
        
End Select

    
    For Each Child In Units
        Set Unit = Child.Find(What, SearchOption)
        If Not (Unit Is Nothing) Then
            Set Find = Unit
            Exit Function
        End If
    Next Child
    
    Set Find = Nothing
    
End Function




Public Function FindEx(Name As String, Level As Long) As CSubdivision

Dim Unit As CSubdivision
Dim Child As CSubdivision
Dim i As Long
Dim r

    If (CStr(Name) = pName) And (CLng(Level) = pLevel) Then
     Set FindEx = Me
     Exit Function
    End If
    
    

    For i = 0 To Units.Count
        If Units.Count = 0 Then Exit For Else Set Unit = Units.Items(i).FindEx(Name, Level)
        If Not (Unit Is Nothing) Then
            Set FindEx = Unit
            Exit Function
        End If
    Next i
    
'    For Each Child In Units
'        Set Unit = Child.FindEx(Name, Level)
'        If Not (Unit Is Nothing) Then
'            Set FindEx = Unit
'            Exit Function
'        End If
'    Next Child
    
    
    
    Set FindEx = Nothing
    
End Function

